/* This file is is generated by a shell script.  DO NOT EDIT! */

/* emulate the original gld for the given avr2
   Copyright 1991, 1992, 1994, 1996, 1999, 2000, 2001, 2002, 2003, 2004
   Free Software Foundation, Inc.
   Written by Steve Chamberlain steve@cygnus.com

This file is part of GLD, the Gnu Linker.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA 02110-1301, USA.  */

#define TARGET_IS_avr2

#include "bfd.h"
#include "sysdep.h"
#include "bfdlink.h"

#include "ld.h"
#include "ldmain.h"
#include "ldmisc.h"

#include "ldexp.h"
#include "ldlang.h"
#include "ldfile.h"
#include "ldemul.h"


static void
gldavr2_before_parse (void)
{
#ifndef TARGET_			/* I.e., if not generic.  */
  ldfile_set_output_arch ("avr:2", bfd_arch_unknown);
#endif /* not TARGET_ */
}


static char *
gldavr2_get_script (int *isfile)
{
  *isfile = 0;

  if (link_info.relocatable && config.build_constructors)
    return
"/* Script for ld -Ur: link w/out relocation, do create constructors */\n\
OUTPUT_FORMAT(\"elf32-avr\",\"elf32-avr\",\"elf32-avr\")\n\
OUTPUT_ARCH(avr:2)\n\
MEMORY\n\
{\n\
  text   (rx)   : ORIGIN = 0, LENGTH = 8K\n\
  data   (rw!x) : ORIGIN = 0x800060, LENGTH = 0xffa0\n\
  eeprom (rw!x) : ORIGIN = 0x810000, LENGTH = 64K\n\
}\n\
SECTIONS\n\
{\n\
  /* Read-only sections, merged into text segment: */\n\
  .hash        0 : { *(.hash)		}\n\
  .dynsym      0 : { *(.dynsym)		}\n\
  .dynstr      0 : { *(.dynstr)		}\n\
  .gnu.version 0 : { *(.gnu.version)	}\n\
  .gnu.version_d 0 : { *(.gnu.version_d)	}\n\
  .gnu.version_r 0 : { *(.gnu.version_r)	}\n\
  .rel.init    0 : { *(.rel.init)		}\n\
  .rela.init   0 : { *(.rela.init)	}\n\
  .rel.text    0 :\n\
    {\n\
      *(.rel.text)\n\
    }\n\
  .rela.text   0 :\n"
"    {\n\
      *(.rela.text)\n\
    }\n\
  .rel.fini    0 : { *(.rel.fini)		}\n\
  .rela.fini   0 : { *(.rela.fini)	}\n\
  .rel.rodata  0 :\n\
    {\n\
      *(.rel.rodata)\n\
    }\n\
  .rela.rodata 0 :\n\
    {\n\
      *(.rela.rodata)\n\
    }\n\
  .rel.data    0 :\n\
    {\n\
      *(.rel.data)\n\
    }\n\
  .rela.data   0 :\n\
    {\n\
      *(.rela.data)\n\
    }\n\
  .rel.ctors   0 : { *(.rel.ctors)	}\n\
  .rela.ctors  0 : { *(.rela.ctors)	}\n\
  .rel.dtors   0 : { *(.rel.dtors)	}\n\
  .rela.dtors  0 : { *(.rela.dtors)	}\n"
"  .rel.got     0 : { *(.rel.got)		}\n\
  .rela.got    0 : { *(.rela.got)		}\n\
  .rel.bss     0 : { *(.rel.bss)		}\n\
  .rela.bss    0 : { *(.rela.bss)		}\n\
  .rel.plt     0 : { *(.rel.plt)		}\n\
  .rela.plt    0 : { *(.rela.plt)		}\n\
  /* Internal text space or external memory */\n\
  .text :\n\
  {\n\
    *(.vectors)\n\
    KEEP(*(.vectors))\n\
     __ctors_start = . ;\n\
     *(.ctors)\n\
     __ctors_end = . ;\n\
     __dtors_start = . ;\n\
     *(.dtors)\n\
     __dtors_end = . ;\n\
    KEEP(SORT(*)(.ctors))\n\
    KEEP(SORT(*)(.dtors))\n\
    /* For data that needs to reside in the lower 64k of progmem */\n\
    *(.progmem.gcc*)\n\
    *(.progmem*)\n\
    /* for future tablejump instruction arrays for 3 byte pc devices */\n\
    *(.jumptables)\n\
    *(.jumptables*)\n"
"    /* for code that needs to reside in the lower 128k progmem */\n\
    *(.lowtext)\n\
    *(.lowtext*)\n\
    *(.init0)  /* Start here after reset.  */\n\
    KEEP (*(.init0))\n\
    *(.init1)\n\
    KEEP (*(.init1))\n\
    *(.init2)  /* Clear __zero_reg__, set up stack pointer.  */\n\
    KEEP (*(.init2))\n\
    *(.init3)\n\
    KEEP (*(.init3))\n\
    *(.init4)  /* Initialize data and BSS.  */\n\
    KEEP (*(.init4))\n\
    *(.init5)\n\
    KEEP (*(.init5))\n\
    *(.init6)  /* C++ constructors.  */\n\
    KEEP (*(.init6))\n\
    *(.init7)\n\
    KEEP (*(.init7))\n\
    *(.init8)\n\
    KEEP (*(.init8))\n\
    *(.init9)  /* Call main().  */\n\
    KEEP (*(.init9))\n\
    *(.text)\n\
    *(.text.*)\n"
"    *(.fini9)  /* _exit() starts here.  */\n\
    KEEP (*(.fini9))\n\
    *(.fini8)\n\
    KEEP (*(.fini8))\n\
    *(.fini7)\n\
    KEEP (*(.fini7))\n\
    *(.fini6)  /* C++ destructors.  */\n\
    KEEP (*(.fini6))\n\
    *(.fini5)\n\
    KEEP (*(.fini5))\n\
    *(.fini4)\n\
    KEEP (*(.fini4))\n\
    *(.fini3)\n\
    KEEP (*(.fini3))\n\
    *(.fini2)\n\
    KEEP (*(.fini2))\n\
    *(.fini1)\n\
    KEEP (*(.fini1))\n\
    *(.fini0)  /* Infinite loop after program termination.  */\n\
    KEEP (*(.fini0))\n\
  }\n\
  .data	0 :\n\
  {\n\
    *(.data)\n\
    *(.data*)\n\
    *(.rodata)  /* We need to include .rodata here if gcc is used */\n\
    *(.rodata*) /* with -fdata-sections.  */\n\
    *(.gnu.linkonce.d*)\n\
  }\n\
  .bss  :\n\
  {\n\
    *(.bss)\n\
    *(.bss*)\n\
    *(COMMON)\n\
  }\n\
  /* Global data not cleared after reset.  */\n\
  .noinit  :\n\
  {\n\
    *(.noinit*)\n\
  }\n\
  .eeprom 0:\n\
  {\n\
    *(.eeprom*)\n\
  }\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1 */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2 */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2 */\n\
  .debug_info     0 : { *(.debug_info) *(.gnu.linkonce.wi.*) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
}\n\n"
  ; else if (link_info.relocatable) return
"/* Script for ld -r: link without relocation */\n\
OUTPUT_FORMAT(\"elf32-avr\",\"elf32-avr\",\"elf32-avr\")\n\
OUTPUT_ARCH(avr:2)\n\
MEMORY\n\
{\n\
  text   (rx)   : ORIGIN = 0, LENGTH = 8K\n\
  data   (rw!x) : ORIGIN = 0x800060, LENGTH = 0xffa0\n\
  eeprom (rw!x) : ORIGIN = 0x810000, LENGTH = 64K\n\
}\n\
SECTIONS\n\
{\n\
  /* Read-only sections, merged into text segment: */\n\
  .hash        0 : { *(.hash)		}\n\
  .dynsym      0 : { *(.dynsym)		}\n\
  .dynstr      0 : { *(.dynstr)		}\n\
  .gnu.version 0 : { *(.gnu.version)	}\n\
  .gnu.version_d 0 : { *(.gnu.version_d)	}\n\
  .gnu.version_r 0 : { *(.gnu.version_r)	}\n\
  .rel.init    0 : { *(.rel.init)		}\n\
  .rela.init   0 : { *(.rela.init)	}\n\
  .rel.text    0 :\n\
    {\n\
      *(.rel.text)\n\
    }\n\
  .rela.text   0 :\n"
"    {\n\
      *(.rela.text)\n\
    }\n\
  .rel.fini    0 : { *(.rel.fini)		}\n\
  .rela.fini   0 : { *(.rela.fini)	}\n\
  .rel.rodata  0 :\n\
    {\n\
      *(.rel.rodata)\n\
    }\n\
  .rela.rodata 0 :\n\
    {\n\
      *(.rela.rodata)\n\
    }\n\
  .rel.data    0 :\n\
    {\n\
      *(.rel.data)\n\
    }\n\
  .rela.data   0 :\n\
    {\n\
      *(.rela.data)\n\
    }\n\
  .rel.ctors   0 : { *(.rel.ctors)	}\n\
  .rela.ctors  0 : { *(.rela.ctors)	}\n\
  .rel.dtors   0 : { *(.rel.dtors)	}\n\
  .rela.dtors  0 : { *(.rela.dtors)	}\n"
"  .rel.got     0 : { *(.rel.got)		}\n\
  .rela.got    0 : { *(.rela.got)		}\n\
  .rel.bss     0 : { *(.rel.bss)		}\n\
  .rela.bss    0 : { *(.rela.bss)		}\n\
  .rel.plt     0 : { *(.rel.plt)		}\n\
  .rela.plt    0 : { *(.rela.plt)		}\n\
  /* Internal text space or external memory */\n\
  .text :\n\
  {\n\
    *(.vectors)\n\
    KEEP(*(.vectors))\n\
    KEEP(SORT(*)(.ctors))\n\
    KEEP(SORT(*)(.dtors))\n\
    /* For data that needs to reside in the lower 64k of progmem */\n\
    *(.progmem.gcc*)\n\
    *(.progmem*)\n\
    /* for future tablejump instruction arrays for 3 byte pc devices */\n\
    *(.jumptables)\n\
    *(.jumptables*)\n\
    /* for code that needs to reside in the lower 128k progmem */\n\
    *(.lowtext)\n\
    *(.lowtext*)\n\
    *(.init0)  /* Start here after reset.  */\n\
    KEEP (*(.init0))\n\
    *(.init1)\n"
"    KEEP (*(.init1))\n\
    *(.init2)  /* Clear __zero_reg__, set up stack pointer.  */\n\
    KEEP (*(.init2))\n\
    *(.init3)\n\
    KEEP (*(.init3))\n\
    *(.init4)  /* Initialize data and BSS.  */\n\
    KEEP (*(.init4))\n\
    *(.init5)\n\
    KEEP (*(.init5))\n\
    *(.init6)  /* C++ constructors.  */\n\
    KEEP (*(.init6))\n\
    *(.init7)\n\
    KEEP (*(.init7))\n\
    *(.init8)\n\
    KEEP (*(.init8))\n\
    *(.init9)  /* Call main().  */\n\
    KEEP (*(.init9))\n\
    *(.text)\n\
    *(.text.*)\n\
    *(.fini9)  /* _exit() starts here.  */\n\
    KEEP (*(.fini9))\n\
    *(.fini8)\n\
    KEEP (*(.fini8))\n\
    *(.fini7)\n\
    KEEP (*(.fini7))\n"
"    *(.fini6)  /* C++ destructors.  */\n\
    KEEP (*(.fini6))\n\
    *(.fini5)\n\
    KEEP (*(.fini5))\n\
    *(.fini4)\n\
    KEEP (*(.fini4))\n\
    *(.fini3)\n\
    KEEP (*(.fini3))\n\
    *(.fini2)\n\
    KEEP (*(.fini2))\n\
    *(.fini1)\n\
    KEEP (*(.fini1))\n\
    *(.fini0)  /* Infinite loop after program termination.  */\n\
    KEEP (*(.fini0))\n\
  }\n\
  .data	0 :\n\
  {\n\
    *(.data)\n\
    *(.data*)\n\
    *(.rodata)  /* We need to include .rodata here if gcc is used */\n\
    *(.rodata*) /* with -fdata-sections.  */\n\
    *(.gnu.linkonce.d*)\n\
  }\n\
  .bss  :\n\
  {\n\
    *(.bss)\n\
    *(.bss*)\n\
    *(COMMON)\n\
  }\n\
  /* Global data not cleared after reset.  */\n\
  .noinit  :\n\
  {\n\
    *(.noinit*)\n\
  }\n\
  .eeprom 0:\n\
  {\n\
    *(.eeprom*)\n\
  }\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1 */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2 */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2 */\n\
  .debug_info     0 : { *(.debug_info) *(.gnu.linkonce.wi.*) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
}\n\n"
  ; else if (!config.text_read_only) return
"/* Script for -N: mix text and data on same page; don't align data */\n\
OUTPUT_FORMAT(\"elf32-avr\",\"elf32-avr\",\"elf32-avr\")\n\
OUTPUT_ARCH(avr:2)\n\
MEMORY\n\
{\n\
  text   (rx)   : ORIGIN = 0, LENGTH = 8K\n\
  data   (rw!x) : ORIGIN = 0x800060, LENGTH = 0xffa0\n\
  eeprom (rw!x) : ORIGIN = 0x810000, LENGTH = 64K\n\
}\n\
SECTIONS\n\
{\n\
  /* Read-only sections, merged into text segment: */\n\
  .hash          : { *(.hash)		}\n\
  .dynsym        : { *(.dynsym)		}\n\
  .dynstr        : { *(.dynstr)		}\n\
  .gnu.version   : { *(.gnu.version)	}\n\
  .gnu.version_d   : { *(.gnu.version_d)	}\n\
  .gnu.version_r   : { *(.gnu.version_r)	}\n\
  .rel.init      : { *(.rel.init)		}\n\
  .rela.init     : { *(.rela.init)	}\n\
  .rel.text      :\n\
    {\n\
      *(.rel.text)\n\
      *(.rel.text.*)\n\
      *(.rel.gnu.linkonce.t*)\n"
"    }\n\
  .rela.text     :\n\
    {\n\
      *(.rela.text)\n\
      *(.rela.text.*)\n\
      *(.rela.gnu.linkonce.t*)\n\
    }\n\
  .rel.fini      : { *(.rel.fini)		}\n\
  .rela.fini     : { *(.rela.fini)	}\n\
  .rel.rodata    :\n\
    {\n\
      *(.rel.rodata)\n\
      *(.rel.rodata.*)\n\
      *(.rel.gnu.linkonce.r*)\n\
    }\n\
  .rela.rodata   :\n\
    {\n\
      *(.rela.rodata)\n\
      *(.rela.rodata.*)\n\
      *(.rela.gnu.linkonce.r*)\n\
    }\n\
  .rel.data      :\n\
    {\n\
      *(.rel.data)\n\
      *(.rel.data.*)\n"
"      *(.rel.gnu.linkonce.d*)\n\
    }\n\
  .rela.data     :\n\
    {\n\
      *(.rela.data)\n\
      *(.rela.data.*)\n\
      *(.rela.gnu.linkonce.d*)\n\
    }\n\
  .rel.ctors     : { *(.rel.ctors)	}\n\
  .rela.ctors    : { *(.rela.ctors)	}\n\
  .rel.dtors     : { *(.rel.dtors)	}\n\
  .rela.dtors    : { *(.rela.dtors)	}\n\
  .rel.got       : { *(.rel.got)		}\n\
  .rela.got      : { *(.rela.got)		}\n\
  .rel.bss       : { *(.rel.bss)		}\n\
  .rela.bss      : { *(.rela.bss)		}\n\
  .rel.plt       : { *(.rel.plt)		}\n\
  .rela.plt      : { *(.rela.plt)		}\n\
  /* Internal text space or external memory */\n\
  .text :\n\
  {\n\
    *(.vectors)\n\
    KEEP(*(.vectors))\n\
     __ctors_start = . ;\n\
     *(.ctors)\n"
"     __ctors_end = . ;\n\
     __dtors_start = . ;\n\
     *(.dtors)\n\
     __dtors_end = . ;\n\
    KEEP(SORT(*)(.ctors))\n\
    KEEP(SORT(*)(.dtors))\n\
    /* For data that needs to reside in the lower 64k of progmem */\n\
    *(.progmem.gcc*)\n\
    *(.progmem*)\n\
    . = ALIGN(2);\n\
    /* for future tablejump instruction arrays for 3 byte pc devices */\n\
    *(.jumptables)\n\
    *(.jumptables*)\n\
    /* for code that needs to reside in the lower 128k progmem */\n\
    *(.lowtext)\n\
    *(.lowtext*)\n\
    *(.init0)  /* Start here after reset.  */\n\
    KEEP (*(.init0))\n\
    *(.init1)\n\
    KEEP (*(.init1))\n\
    *(.init2)  /* Clear __zero_reg__, set up stack pointer.  */\n\
    KEEP (*(.init2))\n\
    *(.init3)\n\
    KEEP (*(.init3))\n\
    *(.init4)  /* Initialize data and BSS.  */\n"
"    KEEP (*(.init4))\n\
    *(.init5)\n\
    KEEP (*(.init5))\n\
    *(.init6)  /* C++ constructors.  */\n\
    KEEP (*(.init6))\n\
    *(.init7)\n\
    KEEP (*(.init7))\n\
    *(.init8)\n\
    KEEP (*(.init8))\n\
    *(.init9)  /* Call main().  */\n\
    KEEP (*(.init9))\n\
    *(.text)\n\
    . = ALIGN(2);\n\
    *(.text.*)\n\
    . = ALIGN(2);\n\
    *(.fini9)  /* _exit() starts here.  */\n\
    KEEP (*(.fini9))\n\
    *(.fini8)\n\
    KEEP (*(.fini8))\n\
    *(.fini7)\n\
    KEEP (*(.fini7))\n\
    *(.fini6)  /* C++ destructors.  */\n\
    KEEP (*(.fini6))\n\
    *(.fini5)\n\
    KEEP (*(.fini5))\n\
    *(.fini4)\n\
    KEEP (*(.fini4))\n\
    *(.fini3)\n\
    KEEP (*(.fini3))\n\
    *(.fini2)\n\
    KEEP (*(.fini2))\n\
    *(.fini1)\n\
    KEEP (*(.fini1))\n\
    *(.fini0)  /* Infinite loop after program termination.  */\n\
    KEEP (*(.fini0))\n\
     _etext = . ;\n\
  }  > text\n\
  .data	  : AT (ADDR (.text) + SIZEOF (.text))\n\
  {\n\
     PROVIDE (__data_start = .) ;\n\
    *(.data)\n\
    *(.data*)\n\
    *(.rodata)  /* We need to include .rodata here if gcc is used */\n\
    *(.rodata*) /* with -fdata-sections.  */\n\
    *(.gnu.linkonce.d*)\n\
    . = ALIGN(2);\n\
     _edata = . ;\n\
     PROVIDE (__data_end = .) ;\n\
  }  > data\n\
  .bss  SIZEOF(.data) + ADDR(.data) :\n\
  {\n\
     PROVIDE (__bss_start = .) ;\n\
    *(.bss)\n\
    *(.bss*)\n\
    *(COMMON)\n\
     PROVIDE (__bss_end = .) ;\n\
  }  > data\n\
   __data_load_start = LOADADDR(.data);\n\
   __data_load_end = __data_load_start + SIZEOF(.data);\n\
  /* Global data not cleared after reset.  */\n\
  .noinit  SIZEOF(.bss) + ADDR(.bss) :\n\
  {\n\
     PROVIDE (__noinit_start = .) ;\n\
    *(.noinit*)\n\
     PROVIDE (__noinit_end = .) ;\n\
     _end = . ;\n\
     PROVIDE (__heap_start = .) ;\n\
  }  > data\n\
  .eeprom  :\n\
  {\n\
    *(.eeprom*)\n\
     __eeprom_end = . ;\n\
  }  > eeprom\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1 */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2 */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2 */\n\
  .debug_info     0 : { *(.debug_info) *(.gnu.linkonce.wi.*) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
}\n\n"
  ; else if (!config.magic_demand_paged) return
"/* Script for -n: mix text and data on same page */\n\
OUTPUT_FORMAT(\"elf32-avr\",\"elf32-avr\",\"elf32-avr\")\n\
OUTPUT_ARCH(avr:2)\n\
MEMORY\n\
{\n\
  text   (rx)   : ORIGIN = 0, LENGTH = 8K\n\
  data   (rw!x) : ORIGIN = 0x800060, LENGTH = 0xffa0\n\
  eeprom (rw!x) : ORIGIN = 0x810000, LENGTH = 64K\n\
}\n\
SECTIONS\n\
{\n\
  /* Read-only sections, merged into text segment: */\n\
  .hash          : { *(.hash)		}\n\
  .dynsym        : { *(.dynsym)		}\n\
  .dynstr        : { *(.dynstr)		}\n\
  .gnu.version   : { *(.gnu.version)	}\n\
  .gnu.version_d   : { *(.gnu.version_d)	}\n\
  .gnu.version_r   : { *(.gnu.version_r)	}\n\
  .rel.init      : { *(.rel.init)		}\n\
  .rela.init     : { *(.rela.init)	}\n\
  .rel.text      :\n\
    {\n\
      *(.rel.text)\n\
      *(.rel.text.*)\n\
      *(.rel.gnu.linkonce.t*)\n"
"    }\n\
  .rela.text     :\n\
    {\n\
      *(.rela.text)\n\
      *(.rela.text.*)\n\
      *(.rela.gnu.linkonce.t*)\n\
    }\n\
  .rel.fini      : { *(.rel.fini)		}\n\
  .rela.fini     : { *(.rela.fini)	}\n\
  .rel.rodata    :\n\
    {\n\
      *(.rel.rodata)\n\
      *(.rel.rodata.*)\n\
      *(.rel.gnu.linkonce.r*)\n\
    }\n\
  .rela.rodata   :\n\
    {\n\
      *(.rela.rodata)\n\
      *(.rela.rodata.*)\n\
      *(.rela.gnu.linkonce.r*)\n\
    }\n\
  .rel.data      :\n\
    {\n\
      *(.rel.data)\n\
      *(.rel.data.*)\n"
"      *(.rel.gnu.linkonce.d*)\n\
    }\n\
  .rela.data     :\n\
    {\n\
      *(.rela.data)\n\
      *(.rela.data.*)\n\
      *(.rela.gnu.linkonce.d*)\n\
    }\n\
  .rel.ctors     : { *(.rel.ctors)	}\n\
  .rela.ctors    : { *(.rela.ctors)	}\n\
  .rel.dtors     : { *(.rel.dtors)	}\n\
  .rela.dtors    : { *(.rela.dtors)	}\n\
  .rel.got       : { *(.rel.got)		}\n\
  .rela.got      : { *(.rela.got)		}\n\
  .rel.bss       : { *(.rel.bss)		}\n\
  .rela.bss      : { *(.rela.bss)		}\n\
  .rel.plt       : { *(.rel.plt)		}\n\
  .rela.plt      : { *(.rela.plt)		}\n\
  /* Internal text space or external memory */\n\
  .text :\n\
  {\n\
    *(.vectors)\n\
    KEEP(*(.vectors))\n\
     __ctors_start = . ;\n\
     *(.ctors)\n"
"     __ctors_end = . ;\n\
     __dtors_start = . ;\n\
     *(.dtors)\n\
     __dtors_end = . ;\n\
    KEEP(SORT(*)(.ctors))\n\
    KEEP(SORT(*)(.dtors))\n\
    /* For data that needs to reside in the lower 64k of progmem */\n\
    *(.progmem.gcc*)\n\
    *(.progmem*)\n\
    . = ALIGN(2);\n\
    /* for future tablejump instruction arrays for 3 byte pc devices */\n\
    *(.jumptables)\n\
    *(.jumptables*)\n\
    /* for code that needs to reside in the lower 128k progmem */\n\
    *(.lowtext)\n\
    *(.lowtext*)\n\
    *(.init0)  /* Start here after reset.  */\n\
    KEEP (*(.init0))\n\
    *(.init1)\n\
    KEEP (*(.init1))\n\
    *(.init2)  /* Clear __zero_reg__, set up stack pointer.  */\n\
    KEEP (*(.init2))\n\
    *(.init3)\n\
    KEEP (*(.init3))\n\
    *(.init4)  /* Initialize data and BSS.  */\n"
"    KEEP (*(.init4))\n\
    *(.init5)\n\
    KEEP (*(.init5))\n\
    *(.init6)  /* C++ constructors.  */\n\
    KEEP (*(.init6))\n\
    *(.init7)\n\
    KEEP (*(.init7))\n\
    *(.init8)\n\
    KEEP (*(.init8))\n\
    *(.init9)  /* Call main().  */\n\
    KEEP (*(.init9))\n\
    *(.text)\n\
    . = ALIGN(2);\n\
    *(.text.*)\n\
    . = ALIGN(2);\n\
    *(.fini9)  /* _exit() starts here.  */\n\
    KEEP (*(.fini9))\n\
    *(.fini8)\n\
    KEEP (*(.fini8))\n\
    *(.fini7)\n\
    KEEP (*(.fini7))\n\
    *(.fini6)  /* C++ destructors.  */\n\
    KEEP (*(.fini6))\n\
    *(.fini5)\n\
    KEEP (*(.fini5))\n\
    *(.fini4)\n\
    KEEP (*(.fini4))\n\
    *(.fini3)\n\
    KEEP (*(.fini3))\n\
    *(.fini2)\n\
    KEEP (*(.fini2))\n\
    *(.fini1)\n\
    KEEP (*(.fini1))\n\
    *(.fini0)  /* Infinite loop after program termination.  */\n\
    KEEP (*(.fini0))\n\
     _etext = . ;\n\
  }  > text\n\
  .data	  : AT (ADDR (.text) + SIZEOF (.text))\n\
  {\n\
     PROVIDE (__data_start = .) ;\n\
    *(.data)\n\
    *(.data*)\n\
    *(.rodata)  /* We need to include .rodata here if gcc is used */\n\
    *(.rodata*) /* with -fdata-sections.  */\n\
    *(.gnu.linkonce.d*)\n\
    . = ALIGN(2);\n\
     _edata = . ;\n\
     PROVIDE (__data_end = .) ;\n\
  }  > data\n\
  .bss  SIZEOF(.data) + ADDR(.data) :\n\
  {\n\
     PROVIDE (__bss_start = .) ;\n\
    *(.bss)\n\
    *(.bss*)\n\
    *(COMMON)\n\
     PROVIDE (__bss_end = .) ;\n\
  }  > data\n\
   __data_load_start = LOADADDR(.data);\n\
   __data_load_end = __data_load_start + SIZEOF(.data);\n\
  /* Global data not cleared after reset.  */\n\
  .noinit  SIZEOF(.bss) + ADDR(.bss) :\n\
  {\n\
     PROVIDE (__noinit_start = .) ;\n\
    *(.noinit*)\n\
     PROVIDE (__noinit_end = .) ;\n\
     _end = . ;\n\
     PROVIDE (__heap_start = .) ;\n\
  }  > data\n\
  .eeprom  :\n\
  {\n\
    *(.eeprom*)\n\
     __eeprom_end = . ;\n\
  }  > eeprom\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1 */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2 */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2 */\n\
  .debug_info     0 : { *(.debug_info) *(.gnu.linkonce.wi.*) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
}\n\n"
  ; else return
"/* Default linker script, for normal executables */\n\
OUTPUT_FORMAT(\"elf32-avr\",\"elf32-avr\",\"elf32-avr\")\n\
OUTPUT_ARCH(avr:2)\n\
MEMORY\n\
{\n\
  text   (rx)   : ORIGIN = 0, LENGTH = 8K\n\
  data   (rw!x) : ORIGIN = 0x800060, LENGTH = 0xffa0\n\
  eeprom (rw!x) : ORIGIN = 0x810000, LENGTH = 64K\n\
}\n\
SECTIONS\n\
{\n\
  /* Read-only sections, merged into text segment: */\n\
  .hash          : { *(.hash)		}\n\
  .dynsym        : { *(.dynsym)		}\n\
  .dynstr        : { *(.dynstr)		}\n\
  .gnu.version   : { *(.gnu.version)	}\n\
  .gnu.version_d   : { *(.gnu.version_d)	}\n\
  .gnu.version_r   : { *(.gnu.version_r)	}\n\
  .rel.init      : { *(.rel.init)		}\n\
  .rela.init     : { *(.rela.init)	}\n\
  .rel.text      :\n\
    {\n\
      *(.rel.text)\n\
      *(.rel.text.*)\n\
      *(.rel.gnu.linkonce.t*)\n"
"    }\n\
  .rela.text     :\n\
    {\n\
      *(.rela.text)\n\
      *(.rela.text.*)\n\
      *(.rela.gnu.linkonce.t*)\n\
    }\n\
  .rel.fini      : { *(.rel.fini)		}\n\
  .rela.fini     : { *(.rela.fini)	}\n\
  .rel.rodata    :\n\
    {\n\
      *(.rel.rodata)\n\
      *(.rel.rodata.*)\n\
      *(.rel.gnu.linkonce.r*)\n\
    }\n\
  .rela.rodata   :\n\
    {\n\
      *(.rela.rodata)\n\
      *(.rela.rodata.*)\n\
      *(.rela.gnu.linkonce.r*)\n\
    }\n\
  .rel.data      :\n\
    {\n\
      *(.rel.data)\n\
      *(.rel.data.*)\n"
"      *(.rel.gnu.linkonce.d*)\n\
    }\n\
  .rela.data     :\n\
    {\n\
      *(.rela.data)\n\
      *(.rela.data.*)\n\
      *(.rela.gnu.linkonce.d*)\n\
    }\n\
  .rel.ctors     : { *(.rel.ctors)	}\n\
  .rela.ctors    : { *(.rela.ctors)	}\n\
  .rel.dtors     : { *(.rel.dtors)	}\n\
  .rela.dtors    : { *(.rela.dtors)	}\n\
  .rel.got       : { *(.rel.got)		}\n\
  .rela.got      : { *(.rela.got)		}\n\
  .rel.bss       : { *(.rel.bss)		}\n\
  .rela.bss      : { *(.rela.bss)		}\n\
  .rel.plt       : { *(.rel.plt)		}\n\
  .rela.plt      : { *(.rela.plt)		}\n\
  /* Internal text space or external memory */\n\
  .text :\n\
  {\n\
    *(.vectors)\n\
    KEEP(*(.vectors))\n\
     __ctors_start = . ;\n\
     *(.ctors)\n"
"     __ctors_end = . ;\n\
     __dtors_start = . ;\n\
     *(.dtors)\n\
     __dtors_end = . ;\n\
    KEEP(SORT(*)(.ctors))\n\
    KEEP(SORT(*)(.dtors))\n\
    /* For data that needs to reside in the lower 64k of progmem */\n\
    *(.progmem.gcc*)\n\
    *(.progmem*)\n\
    . = ALIGN(2);\n\
    /* for future tablejump instruction arrays for 3 byte pc devices */\n\
    *(.jumptables)\n\
    *(.jumptables*)\n\
    /* for code that needs to reside in the lower 128k progmem */\n\
    *(.lowtext)\n\
    *(.lowtext*)\n\
    *(.init0)  /* Start here after reset.  */\n\
    KEEP (*(.init0))\n\
    *(.init1)\n\
    KEEP (*(.init1))\n\
    *(.init2)  /* Clear __zero_reg__, set up stack pointer.  */\n\
    KEEP (*(.init2))\n\
    *(.init3)\n\
    KEEP (*(.init3))\n\
    *(.init4)  /* Initialize data and BSS.  */\n"
"    KEEP (*(.init4))\n\
    *(.init5)\n\
    KEEP (*(.init5))\n\
    *(.init6)  /* C++ constructors.  */\n\
    KEEP (*(.init6))\n\
    *(.init7)\n\
    KEEP (*(.init7))\n\
    *(.init8)\n\
    KEEP (*(.init8))\n\
    *(.init9)  /* Call main().  */\n\
    KEEP (*(.init9))\n\
    *(.text)\n\
    . = ALIGN(2);\n\
    *(.text.*)\n\
    . = ALIGN(2);\n\
    *(.fini9)  /* _exit() starts here.  */\n\
    KEEP (*(.fini9))\n\
    *(.fini8)\n\
    KEEP (*(.fini8))\n\
    *(.fini7)\n\
    KEEP (*(.fini7))\n\
    *(.fini6)  /* C++ destructors.  */\n\
    KEEP (*(.fini6))\n\
    *(.fini5)\n\
    KEEP (*(.fini5))\n\
    *(.fini4)\n\
    KEEP (*(.fini4))\n\
    *(.fini3)\n\
    KEEP (*(.fini3))\n\
    *(.fini2)\n\
    KEEP (*(.fini2))\n\
    *(.fini1)\n\
    KEEP (*(.fini1))\n\
    *(.fini0)  /* Infinite loop after program termination.  */\n\
    KEEP (*(.fini0))\n\
     _etext = . ;\n\
  }  > text\n\
  .data	  : AT (ADDR (.text) + SIZEOF (.text))\n\
  {\n\
     PROVIDE (__data_start = .) ;\n\
    *(.data)\n\
    *(.data*)\n\
    *(.rodata)  /* We need to include .rodata here if gcc is used */\n\
    *(.rodata*) /* with -fdata-sections.  */\n\
    *(.gnu.linkonce.d*)\n\
    . = ALIGN(2);\n\
     _edata = . ;\n\
     PROVIDE (__data_end = .) ;\n\
  }  > data\n\
  .bss  SIZEOF(.data) + ADDR(.data) :\n\
  {\n\
     PROVIDE (__bss_start = .) ;\n\
    *(.bss)\n\
    *(.bss*)\n\
    *(COMMON)\n\
     PROVIDE (__bss_end = .) ;\n\
  }  > data\n\
   __data_load_start = LOADADDR(.data);\n\
   __data_load_end = __data_load_start + SIZEOF(.data);\n\
  /* Global data not cleared after reset.  */\n\
  .noinit  SIZEOF(.bss) + ADDR(.bss) :\n\
  {\n\
     PROVIDE (__noinit_start = .) ;\n\
    *(.noinit*)\n\
     PROVIDE (__noinit_end = .) ;\n\
     _end = . ;\n\
     PROVIDE (__heap_start = .) ;\n\
  }  > data\n\
  .eeprom  :\n\
  {\n\
    *(.eeprom*)\n\
     __eeprom_end = . ;\n\
  }  > eeprom\n\
  /* Stabs debugging sections.  */\n\
  .stab 0 : { *(.stab) }\n\
  .stabstr 0 : { *(.stabstr) }\n\
  .stab.excl 0 : { *(.stab.excl) }\n\
  .stab.exclstr 0 : { *(.stab.exclstr) }\n\
  .stab.index 0 : { *(.stab.index) }\n\
  .stab.indexstr 0 : { *(.stab.indexstr) }\n\
  .comment 0 : { *(.comment) }\n\
  /* DWARF debug sections.\n\
     Symbols in the DWARF debugging sections are relative to the beginning\n\
     of the section so we begin them at 0.  */\n\
  /* DWARF 1 */\n\
  .debug          0 : { *(.debug) }\n\
  .line           0 : { *(.line) }\n\
  /* GNU DWARF 1 extensions */\n\
  .debug_srcinfo  0 : { *(.debug_srcinfo) }\n\
  .debug_sfnames  0 : { *(.debug_sfnames) }\n\
  /* DWARF 1.1 and DWARF 2 */\n\
  .debug_aranges  0 : { *(.debug_aranges) }\n\
  .debug_pubnames 0 : { *(.debug_pubnames) }\n\
  /* DWARF 2 */\n\
  .debug_info     0 : { *(.debug_info) *(.gnu.linkonce.wi.*) }\n\
  .debug_abbrev   0 : { *(.debug_abbrev) }\n\
  .debug_line     0 : { *(.debug_line) }\n\
  .debug_frame    0 : { *(.debug_frame) }\n\
  .debug_str      0 : { *(.debug_str) }\n\
  .debug_loc      0 : { *(.debug_loc) }\n\
  .debug_macinfo  0 : { *(.debug_macinfo) }\n\
}\n\n"
; }

struct ld_emulation_xfer_struct ld_avr2_emulation =
{
  gldavr2_before_parse,
  syslib_default,
  hll_default,
  after_parse_default,
  after_open_default,
  after_allocation_default,
  set_output_arch_default,
  ldemul_default_target,
  before_allocation_default,
  gldavr2_get_script,
  "avr2",
  "elf32-avr",
  finish_default,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,	/* add_options */
  NULL,	/* handle_option */
  NULL,
  NULL,
  NULL,
  NULL,
  NULL
};
